.386
.model flat,stdcall
option casemap:none
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
LoadBmp proto :DWORD


include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\gdi32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\gdi32.lib

.const

MAXSIZE equ 260



.data
ClassName		 db "BmpView",0
AppName 		 db "Viewer",0

ofn  			 OPENFILENAME <>
FilterString 		 db "bmp files",0,"*.bmp",0,0
buffer 			 db MAXSIZE dup(0)
OpenTitle 		 db "Open BMP file",0

bMask			 dd 00000001111111111111111111111111b
bRotate			 dd 1
bInvert			 dd 0
bBright			 dd 1


bfrtitle		 db 256 dup(0)	
bfrMask			 db 'Mask:',0
bfrRotate		 db 'Rotate&Invert&Bright:',0
fmt			 db '%X',0
bfrMaskValue		 db 10 dup (0) 
bfrTrue			 db 'TRUE',0
bfrFalse		 db 'FALSE',0
bfrdump			 db '  ',0


.data?
hInstance 		       HINSTANCE ?
CommandLine 		       LPSTR ?

bmpheader		       BITMAPFILEHEADER <>
bmpinfo			       BITMAPINFOHEADER <>
hwnd			       dd ?

.code
start:
	
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst,hPrevInst,CmdLine,CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG

	mov   wc.cbSize,sizeof WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,1
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,0,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,479,359,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	invoke ShowWindow, eax,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	.while TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
                .break .IF (!eax)
                invoke TranslateMessage, ADDR msg
                invoke DispatchMessage, ADDR msg
	.endw
	mov     eax,msg.wParam
	ret
WinMain endp
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	Local ps :PAINTSTRUCT

	.if uMsg==WM_DESTROY
		
		invoke KillTimer,hWnd,100
		invoke PostQuitMessage,NULL

	.elseif uMsg==WM_CREATE
		invoke SetTimer,hWnd,100,100,0
	
	.elseif uMsg==WM_TIMER
		invoke lstrcpy,addr bfrtitle,addr bfrMask
		invoke lstrcat,addr bfrtitle,addr bfrdump
		invoke wsprintf,addr bfrMaskValue,addr fmt,bMask 
		invoke lstrcat,addr bfrtitle,addr bfrMaskValue
		invoke lstrcat,addr bfrtitle,addr bfrdump
		invoke lstrcat,addr bfrtitle,addr bfrRotate
		invoke lstrcat,addr bfrtitle,addr bfrdump
		.if bMask & 1000000h
			invoke lstrcat,addr bfrtitle,addr bfrTrue
		.else
			invoke lstrcat,addr bfrtitle,addr bfrFalse
		.endif
		invoke lstrcat,addr bfrtitle,addr bfrdump
		.if bMask & 2000000h
			invoke lstrcat,addr bfrtitle,addr bfrTrue
		.else
			invoke lstrcat,addr bfrtitle,addr bfrFalse
		.endif
		invoke lstrcat,addr bfrtitle,addr bfrdump
		.if bMask & 4000000h
			invoke lstrcat,addr bfrtitle,addr bfrTrue
		.else
			invoke lstrcat,addr bfrtitle,addr bfrFalse
		.endif
		invoke SetWindowText,hWnd,addr bfrtitle
		
	.elseif uMsg==WM_PAINT
		
		invoke BeginPaint,hWnd,addr ps
		mov ecx,ps.rcPaint.right
		mov edx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.left
		sub edx,ps.rcPaint.top
		mov eax,00ffffa6h
		invoke CreateSolidBrush,eax
		invoke SelectObject,ps.hdc,eax
		push eax
		invoke PatBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ecx,edx,PATCOPY
		pop eax
		invoke SelectObject,ps.hdc,eax
		invoke DeleteObject,eax
		invoke EndPaint,hWnd,addr ps

	.elseif uMsg==WM_COMMAND
		mov eax,wParam
		.if ax == 1
			mov ofn.lStructSize,SIZEOF ofn
			push hWnd
			pop  ofn.hWndOwner
			push hInstance
			pop  ofn.hInstance
			mov  ofn.lpstrFilter, OFFSET FilterString
			mov  ofn.lpstrFile, OFFSET buffer
			mov  ofn.nMaxFile,MAXSIZE
			mov  ofn.Flags, OFN_FILEMUSTEXIST or \
                        OFN_PATHMUSTEXIST or OFN_LONGNAMES or\
                        OFN_EXPLORER or OFN_HIDEREADONLY
			mov  ofn.lpstrTitle, OFFSET OpenTitle
			invoke GetOpenFileName, ADDR ofn
			.if eax==TRUE
	
				invoke LoadBmp,ofn.lpstrFile
			.endif
		.elseif ax == 2
			or bMask,0ffffffh
			and bMask,0ff0000ffh
			
		.elseif ax == 3
			or bMask,0ffffffh
			and bMask,0ff00ff00h
		.elseif ax == 4
			or bMask,0ffffffh
			and bMask,0ffff0000h
		.elseif ax == 5
			or bMask,0ffffffh
		.elseif ax == 6
			and bMask,6ffffffh
		.elseif ax == 7
			or bMask,1000000h
		.elseif ax == 8
			or bMask,2ffffffh
		.elseif ax == 9
			and bMask,5ffffffh
		.elseif ax == 10
			or bMask,4ffffffh
		.elseif ax == 11
			and bMask,3ffffffh
		.endif

	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret
WndProc endp

LoadBmp proc pszfile
	Local hFile:DWORD
	Local rdbytes:DWORD
        Local hHeap:DWORD
	Local pHeap:DWORD
	Local spw:DWORD
	Local rect : RECT 
	Local nX:DWORD
	Local nY:DWORD
	Local hDC:DWORD
	Local bmpWidth:DWORD
		

	invoke GetProcessHeap
	mov hHeap,eax
	invoke CreateFile,pszfile,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,0
	mov hFile,eax
	invoke ReadFile,hFile,addr bmpheader,sizeof bmpheader,addr rdbytes,0
	invoke ReadFile,hFile,addr bmpinfo,sizeof bmpinfo,addr rdbytes,0
	;invoke SetWindowPos,hWND,HWND_TOP,0,0,bmpinfo.biWidth,bmpinfo.biHeight,SWP_NOMOVE

;--------calculate the spw-----------
	
	mov eax,bmpinfo.biWidth
	mov ebx,0
	mov ecx,3
	mul ecx
	add ebx,eax    
	add ebx,edx
	mov bmpWidth,ebx	;stores it to bmpWidth
	mov ecx,4
	div ecx
	mov eax,4
	sub eax,edx
	.if eax == 4
		mov eax,0
	.endif
	add eax,ebx
	mov spw,eax	;stores it to spw
	
;------------------------------------






;------------------------------------

	invoke GetClientRect,hwnd,addr rect
	sub rect.right,1
	sub rect.bottom,1
	invoke GetDC,hwnd
	mov hDC,eax

	push bmpinfo.biHeight
	pop ecx
	
	.while ecx > 0
		push ecx
;--------allocate heap---------------
		
		invoke HeapAlloc,hHeap,8,spw
		mov pHeap,eax
	
;------------------------------------

		invoke ReadFile,hFile,pHeap,spw,addr rdbytes,0
	

		
		mov esi,pHeap
		mov edi,bmpWidth

		bt bMask,25
		jnc @f
			.while edi > 0
				mov al,[esi]
				mov bl,0ffh
				sub bl,al
				mov [esi],bl
				inc esi
				dec edi
			.endw

			mov edi,bmpWidth
			sub esi,edi
		@@:

		bt bMask,26
		jnc @f
			.while edi > 0
				mov al,[esi]
				sub al,18
				mov [esi],al
				inc esi
				dec edi
			.endw

			mov edi,bmpWidth
			sub esi,edi
		@@:
            

	
		mov nX,0	
		.while edi > 0
		
			mov eax,[esi]
			mov ebx,bMask
			and ebx,0ffffffh
			and eax,ebx
			bt bMask,24
			jnc @f
				mov ebx,eax
				and ebx,0000FF00h
				rol eax,16
				and eax,0FFFFFFh
				or eax,ebx
			@@:

			invoke SetPixel,hDC,nX,rect.bottom,eax
			inc nX
			add esi,3
			sub edi,3
	
		.endw

		invoke HeapFree,hHeap,0,pHeap	
		dec rect.bottom
		pop ecx
		dec ecx

	.endw
	
	ret
LoadBmp endp




end start
